// SampleCreativeFilter.h : main header file for the SampleCreativeFilter DLL
//

#pragma once

#ifndef __AFXWIN_H__
	#error "include 'stdafx.h' before including this file for PCH"
#endif

#include "resource.h"		// main symbols

struct FilterHeader
{
	WORD	length;			// length of the header in bytes
	BYTE	version;		// header version number
	WORD	width;			// width of image data in pixels
	WORD	height;			// height of image data in pixels
	BYTE	bytesPerPixel;	// number of bytes per pixel (normally this is 3)
	BYTE	photoNumber;	// 1=first photo, 2= second photo etc.
};

__declspec(dllexport) int __stdcall Setup(CWnd* win, const char* regPath);
__declspec(dllexport) int __stdcall ApplyFilter(FilterHeader* header, BYTE* buffer);

// CSampleCreativeFilterApp
// See SampleCreativeFilter.cpp for the implementation of this class
//

class CSampleCreativeFilterApp : public CWinApp
{
public:
	CSampleCreativeFilterApp();

// Overrides
public:
	virtual BOOL InitInstance();

	DECLARE_MESSAGE_MAP()

public:
	static CSampleCreativeFilterApp& GetTheApp();
	int SetupFilter(CWnd* win, const char* regPath);
	int ApplyFilterToBuffer(FilterHeader* header, BYTE* buffer);

	int m_filterType;
	CString m_regPath;
};
