// SampleCreativeFilter.cpp : Defines the initialization routines for the DLL.
//

#include "stdafx.h"
#include "SampleCreativeFilter.h"
#include "SettingsDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

//
//TODO: If this DLL is dynamically linked against the MFC DLLs,
//		any functions exported from this DLL which call into
//		MFC must have the AFX_MANAGE_STATE macro added at the
//		very beginning of the function.
//
//		For example:
//
//		extern "C" BOOL PASCAL EXPORT ExportedFunction()
//		{
//			AFX_MANAGE_STATE(AfxGetStaticModuleState());
//			// normal function body here
//		}
//
//		It is very important that this macro appear in each
//		function, prior to any calls into MFC.  This means that
//		it must appear as the first statement within the 
//		function, even before any object variable declarations
//		as their constructors may generate calls into the MFC
//		DLL.
//
//		Please see MFC Technical Notes 33 and 58 for additional
//		details.
//


// CSampleCreativeFilterApp

BEGIN_MESSAGE_MAP(CSampleCreativeFilterApp, CWinApp)
END_MESSAGE_MAP()


// CSampleCreativeFilterApp construction

CSampleCreativeFilterApp::CSampleCreativeFilterApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}


// The one and only CSampleCreativeFilterApp object

CSampleCreativeFilterApp theApp;

// This function is called by the photobooth software to setup the filter
// Args:
//		win		handle of calling window
__declspec(dllexport) int __stdcall Setup(CWnd* win, const char* regPath)
{
	return theApp.SetupFilter(win, regPath);
}

// This function is called by the photobooth software to setup the filter
// Args:
//		win		handle of calling window
__declspec(dllexport) int __stdcall ApplyFilter(FilterHeader* header, BYTE* buffer)
{
	return theApp.ApplyFilterToBuffer(header, buffer);
}

// CSampleCreativeFilterApp initialization

BOOL CSampleCreativeFilterApp::InitInstance()
{
	CWinApp::InitInstance();

	return TRUE;
}

CSampleCreativeFilterApp& CSampleCreativeFilterApp::GetTheApp()
{
	return theApp;
}

int CSampleCreativeFilterApp::SetupFilter(CWnd* win, const char* regPath)
{
	if (regPath && strlen(regPath) > 10)
	{
		m_regPath = CA2W(regPath);
		m_filterType = 0;
		CRegKey regKey;
		if (regKey.Create(HKEY_CURRENT_USER, m_regPath) == ERROR_SUCCESS)
		{
			DWORD value = 0;
			if (regKey.QueryDWORDValue(_T("SampleFilterType"), value) == ERROR_SUCCESS) m_filterType = value;
		}
	}
	if (win)
	{
		CSettingsDlg dlg(win);
		int filterTypeCopy = m_filterType;
		if (dlg.DoModal() != IDOK)
		{
			m_filterType = filterTypeCopy;
		}

		CRegKey regKey;
		if (regKey.Create(HKEY_CURRENT_USER, m_regPath) == ERROR_SUCCESS)
		{
			DWORD value = 0;
			regKey.SetDWORDValue(_T("SampleFilterType"), m_filterType);
		}
	}
	return 0;
}

int CSampleCreativeFilterApp::ApplyFilterToBuffer(FilterHeader* header, BYTE* buffer)
{
	// Validate header
	if (!header || !buffer) return 1;	// error: no header or no buffer supplied
	if (header->length < sizeof(FilterHeader)) return 2;	// error: header length is too short
	if (header->bytesPerPixel != 3) return 3;	// error: this filter only support 3 byte per pixel RGB images
	if (header->version > 1) return 4;	// error: FilterHeader version has changed

	// We could use header->photoNumber to apply a different effect for each photo

	// Apply filter to image buffer
	BYTE* ptr = buffer;
	switch (m_filterType)
	{
	default:
	case 0:		// color negative
		for (WORD y = 0; y < header->height; y++)
		{
			for (WORD x = 0; x < header->width; x++)
			{
				*ptr = 255 - *ptr;
				ptr++;
				*ptr = 255 - *ptr;
				ptr++;
				*ptr = 255 - *ptr;
				ptr++;
			}
		}
		break;

	case 1:		// monochrome negative
		for (WORD y = 0; y < header->height; y++)
		{
			for (WORD x = 0; x < header->width; x++)
			{
				BYTE g = 255 - ptr[1];
				*ptr++ = g;
				*ptr++ = g;
				*ptr++ = g;
			}
		}
		break;
	}

	return 0;
}
